"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.AdminAuthenticationModule = void 0;
const admin_authentication_controller_1 = require("./admin-authentication.controller");
const admin_authentication_service_1 = require("./admin-authentication.service");
const admin_jwt_sign_option_1 = require("./admin-jwt-sign-option");
const strategies_1 = require("./strategies");
const common_1 = require("@nestjs/common");
const config_1 = require("@nestjs/config");
const jwt_1 = require("@nestjs/jwt");
const passport_1 = require("@nestjs/passport");
let AdminAuthenticationModule = class AdminAuthenticationModule {
};
AdminAuthenticationModule = __decorate([
    (0, common_1.Module)({
        controllers: [admin_authentication_controller_1.AdminAuthenticationController],
        imports: [
            config_1.ConfigModule,
            passport_1.PassportModule,
            jwt_1.JwtModule.registerAsync({
                imports: [config_1.ConfigModule],
                useFactory: async (configService) => {
                    return {
                        privateKey: configService.get('ADMIN_JWT_ACCESS_TOKEN_SECRET_KEY'),
                        publicKey: configService.get('ADMIN_JWT_ACCESS_TOKEN_PUBLIC_KEY'),
                        signOptions: Object.assign({}, (0, admin_jwt_sign_option_1.adminAccessTokenOption)(configService)),
                    };
                },
                inject: [config_1.ConfigService],
            }),
        ],
        providers: [
            admin_authentication_service_1.AdminAuthenticationService,
            strategies_1.AdminLocalStrategy,
            strategies_1.AdminJwtStrategy,
            strategies_1.AdminJwtRefreshTokenStrategy,
        ],
        exports: [admin_authentication_service_1.AdminAuthenticationService, jwt_1.JwtModule],
    })
], AdminAuthenticationModule);
exports.AdminAuthenticationModule = AdminAuthenticationModule;
//# sourceMappingURL=admin-authentication.module.js.map