"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.AdminPermissionService = void 0;
const admin_permission_dto_1 = require("./dto/admin-permission.dto");
const common_1 = require("@moonlightjs/common");
const common_2 = require("@nestjs/common");
let AdminPermissionService = class AdminPermissionService {
    constructor(prisma) {
        this.prisma = prisma;
    }
    async findOne(params) {
        const adminPermission = await this.prisma.adminPermission.findFirst(params);
        return (0, common_1.toDto)(admin_permission_dto_1.AdminPermissionDto, adminPermission);
    }
    async findAll(params) {
        if (!params.skip) {
            params.skip = 0;
        }
        if (!params.take) {
            params.take = 20;
        }
        const adminPermissions = await this.prisma.adminPermission.findMany(params);
        return adminPermissions.map((adminPermission) => (0, common_1.toDto)(admin_permission_dto_1.AdminPermissionDto, adminPermission));
    }
    async findAllPagination(params) {
        if (!params.skip) {
            params.skip = 0;
        }
        if (!params.take) {
            params.take = 20;
        }
        const [adminPermissions, total] = await Promise.all([
            this.prisma.adminPermission.findMany(params),
            this.prisma.adminPermission.count({
                where: params.where,
            }),
        ]);
        return common_1.PagedResultDto.create({
            data: adminPermissions.map((adminPermission) => (0, common_1.toDto)(admin_permission_dto_1.AdminPermissionDto, adminPermission)),
            pagination: common_1.Pagination.create({
                take: params.take,
                skip: params.skip,
                total: total,
            }),
        });
    }
    async create(params) {
        const adminPermission = await this.prisma.adminPermission.create(params);
        return (0, common_1.toDto)(admin_permission_dto_1.AdminPermissionDto, adminPermission);
    }
    async update(params) {
        const adminPermission = await this.prisma.adminPermission.update(params);
        return (0, common_1.toDto)(admin_permission_dto_1.AdminPermissionDto, adminPermission);
    }
    async remove(where) {
        const adminPermission = await this.prisma.adminPermission.delete({
            where,
        });
        return !!adminPermission;
    }
};
AdminPermissionService = __decorate([
    (0, common_2.Injectable)(),
    __metadata("design:paramtypes", [common_1.PrismaService])
], AdminPermissionService);
exports.AdminPermissionService = AdminPermissionService;
//# sourceMappingURL=admin-permission.service.js.map