import { AdminPolicyService } from './admin-policy.service';
import { AdminPolicyDto } from './dto/admin-policy.dto';
import { CreateAdminPolicyInput } from './dto/create-admin-policy.input';
import { UpdateAdminPolicyInput } from './dto/update-admin-policy.input';
import { Prisma } from '@prisma/client';
export declare class AdminPolicyController {
    protected readonly policyService: AdminPolicyService;
    constructor(policyService: AdminPolicyService);
    create(createAdminPolicyInput: CreateAdminPolicyInput, params: Omit<Prisma.AdminPolicyCreateArgs, 'data'>): Promise<AdminPolicyDto>;
    findAll(params: Prisma.AdminPolicyFindManyArgs): Promise<AdminPolicyDto[]>;
    findAllPagination(params: Prisma.AdminPolicyFindManyArgs): Promise<import("@moonlightjs/common").PagedResultDto<AdminPolicyDto>>;
    findOne(id: string, params: Prisma.AdminPolicyFindUniqueArgs): Promise<AdminPolicyDto>;
    update(id: string, updateAdminPolicyInput: UpdateAdminPolicyInput, params: Omit<Prisma.AdminPolicyUpdateArgs, 'data' | 'where'>): Promise<AdminPolicyDto>;
    remove(id: string): Promise<boolean>;
}
