"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.CreateAdminPolicyInput = exports.PolicyStatementInput = exports.PolicyPrincipalInput = void 0;
const policy_1 = require("../types/policy");
const swagger_1 = require("@nestjs/swagger");
const class_transformer_1 = require("class-transformer");
const class_validator_1 = require("class-validator");
let PolicyPrincipalInput = class PolicyPrincipalInput {
};
__decorate([
    (0, swagger_1.ApiProperty)({ required: true, type: String, isArray: true }),
    (0, class_validator_1.IsString)({
        each: true,
    }),
    (0, class_validator_1.IsArray)(),
    (0, class_transformer_1.Expose)(),
    __metadata("design:type", Object)
], PolicyPrincipalInput.prototype, "Service", void 0);
PolicyPrincipalInput = __decorate([
    (0, class_transformer_1.Expose)()
], PolicyPrincipalInput);
exports.PolicyPrincipalInput = PolicyPrincipalInput;
let PolicyStatementInput = class PolicyStatementInput {
};
__decorate([
    (0, swagger_1.ApiProperty)({ required: true }),
    (0, class_validator_1.IsString)(),
    (0, class_validator_1.IsOptional)(),
    (0, class_transformer_1.Expose)(),
    __metadata("design:type", String)
], PolicyStatementInput.prototype, "Sid", void 0);
__decorate([
    (0, swagger_1.ApiProperty)({ required: true, type: String, enum: policy_1.Effect }),
    (0, class_validator_1.IsEnum)(policy_1.Effect),
    (0, class_transformer_1.Expose)(),
    __metadata("design:type", String)
], PolicyStatementInput.prototype, "Effect", void 0);
__decorate([
    (0, swagger_1.ApiProperty)({ required: true, type: String, isArray: true }),
    (0, class_validator_1.IsString)({
        each: true,
    }),
    (0, class_validator_1.IsArray)(),
    (0, class_validator_1.IsOptional)(),
    (0, class_transformer_1.Expose)(),
    __metadata("design:type", Object)
], PolicyStatementInput.prototype, "Action", void 0);
__decorate([
    (0, swagger_1.ApiProperty)({ required: true, type: String, isArray: true }),
    (0, class_validator_1.IsString)({
        each: true,
    }),
    (0, class_validator_1.IsArray)(),
    (0, class_validator_1.IsOptional)(),
    (0, class_transformer_1.Expose)(),
    __metadata("design:type", Object)
], PolicyStatementInput.prototype, "NotAction", void 0);
__decorate([
    (0, swagger_1.ApiProperty)({ required: true, type: String, isArray: true }),
    (0, class_validator_1.IsString)({
        each: true,
    }),
    (0, class_validator_1.IsArray)(),
    (0, class_validator_1.IsOptional)(),
    (0, class_transformer_1.Expose)(),
    __metadata("design:type", Object)
], PolicyStatementInput.prototype, "Resource", void 0);
__decorate([
    (0, swagger_1.ApiProperty)({ required: true, type: String, isArray: true }),
    (0, class_validator_1.IsString)({
        each: true,
    }),
    (0, class_validator_1.IsArray)(),
    (0, class_validator_1.IsOptional)(),
    (0, class_transformer_1.Expose)(),
    __metadata("design:type", Object)
], PolicyStatementInput.prototype, "NotResource", void 0);
__decorate([
    (0, swagger_1.ApiProperty)({ required: true, type: () => PolicyPrincipalInput }),
    (0, class_validator_1.ValidateNested)(),
    (0, class_transformer_1.Type)(() => PolicyPrincipalInput),
    (0, class_transformer_1.Expose)(),
    __metadata("design:type", Object)
], PolicyStatementInput.prototype, "Principal", void 0);
__decorate([
    (0, swagger_1.ApiProperty)({ required: true, type: () => PolicyPrincipalInput }),
    (0, class_validator_1.ValidateNested)(),
    (0, class_transformer_1.Type)(() => PolicyPrincipalInput),
    (0, class_validator_1.IsOptional)(),
    (0, class_transformer_1.Expose)(),
    __metadata("design:type", Object)
], PolicyStatementInput.prototype, "NotPrincipal", void 0);
__decorate([
    (0, swagger_1.ApiProperty)({ required: true, type: Object }),
    (0, class_validator_1.IsJSON)(),
    (0, class_validator_1.IsOptional)(),
    (0, class_transformer_1.Expose)(),
    __metadata("design:type", Object)
], PolicyStatementInput.prototype, "Condition", void 0);
PolicyStatementInput = __decorate([
    (0, class_transformer_1.Expose)()
], PolicyStatementInput);
exports.PolicyStatementInput = PolicyStatementInput;
let CreateAdminPolicyInput = class CreateAdminPolicyInput {
};
__decorate([
    (0, swagger_1.ApiProperty)({ required: true }),
    (0, class_validator_1.IsString)(),
    (0, class_validator_1.IsNotEmpty)(),
    (0, class_transformer_1.Expose)(),
    __metadata("design:type", String)
], CreateAdminPolicyInput.prototype, "name", void 0);
__decorate([
    (0, swagger_1.ApiProperty)({ required: true }),
    (0, class_validator_1.IsString)(),
    (0, class_transformer_1.Expose)(),
    __metadata("design:type", String)
], CreateAdminPolicyInput.prototype, "version", void 0);
__decorate([
    (0, swagger_1.ApiProperty)({
        required: true,
        type: () => PolicyStatementInput,
        isArray: true,
    }),
    (0, class_validator_1.ValidateNested)({
        each: true,
    }),
    (0, class_validator_1.IsArray)(),
    (0, class_transformer_1.Type)(() => PolicyStatementInput),
    (0, class_transformer_1.Expose)(),
    __metadata("design:type", Array)
], CreateAdminPolicyInput.prototype, "statements", void 0);
__decorate([
    (0, swagger_1.ApiProperty)({ required: false }),
    (0, class_validator_1.IsString)(),
    (0, class_validator_1.IsOptional)(),
    (0, class_transformer_1.Expose)(),
    __metadata("design:type", String)
], CreateAdminPolicyInput.prototype, "description", void 0);
CreateAdminPolicyInput = __decorate([
    (0, class_transformer_1.Expose)()
], CreateAdminPolicyInput);
exports.CreateAdminPolicyInput = CreateAdminPolicyInput;
//# sourceMappingURL=create-admin-policy.input.js.map