"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.AdminRoleService = void 0;
const admin_role_dto_1 = require("./dto/admin-role.dto");
const common_1 = require("@moonlightjs/common");
const common_2 = require("@nestjs/common");
const constants_1 = require("../../../constants");
let AdminRoleService = class AdminRoleService {
    constructor(prisma) {
        this.prisma = prisma;
    }
    async findOne(params) {
        const adminRole = await this.prisma.adminRole.findFirst(params);
        return (0, common_1.toDto)(admin_role_dto_1.AdminRoleDto, adminRole);
    }
    async findAll(params) {
        var _a, _b;
        params.skip = (_a = params.skip) !== null && _a !== void 0 ? _a : constants_1.DEFAULT_SKIP;
        params.take = (_b = params.take) !== null && _b !== void 0 ? _b : constants_1.DEFAULT_TAKE;
        const adminRoles = await this.prisma.adminRole.findMany(params);
        return adminRoles.map((adminRole) => (0, common_1.toDto)(admin_role_dto_1.AdminRoleDto, adminRole));
    }
    async findAllPagination(params) {
        var _a, _b;
        params.skip = (_a = params.skip) !== null && _a !== void 0 ? _a : constants_1.DEFAULT_SKIP;
        params.take = (_b = params.take) !== null && _b !== void 0 ? _b : constants_1.DEFAULT_TAKE;
        const [adminRoles, total] = await Promise.all([
            this.prisma.adminRole.findMany(params),
            this.prisma.adminRole.count({
                where: params.where,
            }),
        ]);
        return common_1.PagedResultDto.create({
            data: adminRoles.map((adminRole) => (0, common_1.toDto)(admin_role_dto_1.AdminRoleDto, adminRole)),
            pagination: common_1.Pagination.create({
                take: params.take,
                skip: params.skip,
                total: total,
            }),
        });
    }
    async create(params) {
        const adminRole = await this.prisma.adminRole.create(params);
        return (0, common_1.toDto)(admin_role_dto_1.AdminRoleDto, adminRole);
    }
    async update(params) {
        const adminRole = await this.prisma.adminRole.update(params);
        return (0, common_1.toDto)(admin_role_dto_1.AdminRoleDto, adminRole);
    }
    async remove(where) {
        const adminRole = await this.prisma.adminRole.delete({
            where,
        });
        return !!adminRole;
    }
};
AdminRoleService = __decorate([
    (0, common_2.Injectable)(),
    __metadata("design:paramtypes", [common_1.PrismaService])
], AdminRoleService);
exports.AdminRoleService = AdminRoleService;
//# sourceMappingURL=admin-role.service.js.map